#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/sendfile.h>
#include <errno.h>

int main(int argc, const char*const* argv)
{
    if(argc != 3)
    {
        puts("Usage: copy <begin> <count> < <filename> > <output>");
        return 0;
    }
    
    off_t begin = strtoll(argv[1], 0, 10);
    off_t count = strtoll(argv[2], 0, 10);
    
    fseeko(stdin, begin, SEEK_SET);
    
    bool sendfile_failed = false;
    
    while(count > 0)
    {
        if(!sendfile_failed)
        {
            ssize_t tmp = sendfile(1,0, &begin, count);
            if(tmp == -1)
                sendfile_failed = true;
            else
                { begin += tmp; count -= tmp; continue; }
        }
    
        char Buf[32768];
        long eat = sizeof(Buf);
        if(eat > count) eat = count;
        size_t freadres = fread(Buf, 1, eat, stdin);
        size_t fwriteres = fwrite(Buf, 1, eat, stdout);
        if(fwriteres == 0) return errno;
        if(freadres == -1) return errno;
        if(freadres < eat) break;
        count -= eat;
    }
    return 0;
}
