BASE=/mnt/gbatmp/psx-rerec/output

UTILDIR=recording-showcase

ID="$1"
AVIOUT="$ID".avi
STITCHPARAMS="$2 $3"

if true; then
	./$UTILDIR/stitch $STITCHPARAMS < $BASE.log > $BASE.tmp"$ID"

	egrep "< Video|^# Video" $BASE.tmp"$ID" \
		| sed "s/Video//;s@^c@$UTILDIR/c@;s@\$@ $BASE.vid \&\& \\\\@" \
		> $BASE.vidcmd"$ID"

	egrep "< Audio|^# Audio" $BASE.tmp"$ID" \
		| sed "s/Audio//;s@^c@$UTILDIR/c@;s@\$@ $BASE.aud \&\& \\\\@" \
		> $BASE.audcmd"$ID"

	echo true >> $BASE.vidcmd"$ID"
	echo true >> $BASE.audcmd"$ID"
fi

rm -f $BASE.tmp"$ID"

chmod +x $BASE.vidcmd"$ID" $BASE.audcmd"$ID"

rm -f s.log"$ID"
mkfifo s.log"$ID"

X264OPTS="crf=10:turbo=2:threads=4"
LAMEOPTS="aq=9:fast:preset=standard"

#X264OPTS="crf=22:partitions=all:me=umh:frameref=15:me_range=64:bime:brdo:mixed_refs:trellis=2:ratetol=60:subq=7:direct_pred=auto"
#LAMEOPTS="aq=0:preset=70"

#VC="-ovc x264 -x264encopts $X264OPTS"
AC="-oac mp3lame -lameopts $LAMEOPTS"

#VC="-ovc lavc -lavcopts vcodec=mpeg4:vqscale=9:me_range=4"
VC="-ovc xvid -xvidencopts pass=1:turbo:me_quality=1:bitrate=300:max_key_interval=120"
#VC="-ovc copy"

(sh -c $BASE.audcmd"$ID" > s.log"$ID" 2>audtrace.log"$ID" ) &

(sh -c $BASE.vidcmd"$ID"              2>vidtrace.log"$ID") | \
	mencoder - -demuxer h264es \
	-nocache \
	-audiofile s.log"$ID" \
	-audio-demuxer rawaudio \
	-rawaudio channels=2:rate=44100:samplesize=2:bitrate=$[44100*4] \
	$AC \
	$VC \
	-mc 0 \
	-vf decimate=10:0:0:1 \
	-o "$AVIOUT"
